package com.nisum.offertransactionservice.service;

import com.nisum.offertransactionservice.converter.OfferConverter;
import com.nisum.offertransactionservice.converter.PEResponseToOfferTransactionResConverter;
import com.nisum.offertransactionservice.dao.OfferDao;
import com.nisum.offertransactionservice.dao.OfferLookupRepo;
import com.nisum.offertransactionservice.model.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

import static com.google.common.collect.Lists.newArrayList;

@Service
public class OfferCallingPEService {
    @Autowired
    private OfferConverter offerConverter;

    @Autowired
    private OfferLookupRepo offerLookupRepo;

    @Autowired
    private OfferDao offerDao;
    @Autowired
    private PEResponseToOfferTransactionResConverter peResponseToOfferTransactionResConverter;

    public OfferTransactionResponse getDiscountedItemList(OfferTransactionRequest offerTransactionRequest) {
        List<OfferLookup> eligibleOffer = newArrayList();
        offerLookupRepo.findAll().forEach(eligibleOffer::add);
        OfferTransactionResponse offerTransactionResponse ;
        PERequest peRequest = offerConverter.apply(offerTransactionRequest);
        peRequest.setEligibleOffers(eligibleOffer);
        PEResponse peResponse = offerDao.callPE(peRequest);
        offerTransactionResponse = peResponseToOfferTransactionResConverter.apply(peResponse);
        return offerTransactionResponse;
    }
}
